
//
// Written By Holguer Andres Becerrra Daza
// for more code and examples: www.fpgalover.com
//

//=======================================================
//  This code is generated by Terasic System Builder
//=======================================================

module D5M_Example(

	//////////// CLOCK //////////
	input 		          		CLOCK_125_p,
	input 		          		CLOCK_50_B5B,
	input 		          		CLOCK_50_B6A,
	input 		          		CLOCK_50_B7A,
	input 		          		CLOCK_50_B8A,

	//////////// LED //////////
	output		     [7:0]		LEDG,
	output		     [9:0]		LEDR,

	//////////// KEY //////////
	input 		          		CPU_RESET_n,
	input 		     [3:0]		KEY,

	//////////// SW //////////
	input 		     [9:0]		SW,

	//////////// HDMI-TX //////////
	output		          		HDMI_TX_CLK,
	output		    [23:0]		HDMI_TX_D,
	output		          		HDMI_TX_DE,
	output		          		HDMI_TX_HS,
	input 		          		HDMI_TX_INT,
	output		          		HDMI_TX_VS,

	//////////// I2C for Audio/HDMI-TX/Si5338/HSMC //////////
	output		          		I2C_SCL,
	inout 		          		I2C_SDA,

	//////////// LPDDR2 //////////
	output		     [9:0]		DDR2LP_CA,
	output		          		DDR2LP_CK_n,
	output		          		DDR2LP_CK_p,
	output		     [1:0]		DDR2LP_CKE,
	output		     [1:0]		DDR2LP_CS_n,
	output		     [3:0]		DDR2LP_DM,
	inout 		    [31:0]		DDR2LP_DQ,
	inout 		     [3:0]		DDR2LP_DQS_n,
	inout 		     [3:0]		DDR2LP_DQS_p,
	input 		          		DDR2LP_OCT_RZQ,

	//////////// GPIO, GPIO connect to D5M - 5M Pixel Camera //////////
	input 		    [11:0]		D5M_D,
	input 		          		D5M_FVAL,
	input 		          		D5M_LVAL,
	input 		          		D5M_PIXCLK,
	output		          		D5M_RESET_N,
	output		          		D5M_SCLK,
	inout 		          		D5M_SDATA,
	input 		          		D5M_STROBE,
	output		          		D5M_TRIGGER,
	output		          		D5M_XCLKIN
);



//=======================================================
//  REG/WIRE declarations
//=======================================================

wire reset_n;
reg		[11:0]	rCCD_DATA;
reg				rCCD_LVAL;
reg				rCCD_FVAL;
wire	[11:0]	mCCD_DATA;
wire			mCCD_DVAL;
wire			mCCD_DVAL_d;
wire	[15:0]	X_Cont;
wire	[15:0]	Y_Cont;
wire	[31:0]	Frame_Cont;
wire			DLY_RST_0;
wire			DLY_RST_1;
wire			DLY_RST_2;
wire			DLY_RST_3;
wire			DLY_RST_4;
wire	[11:0]	sCCD_R;
wire	[11:0]	sCCD_G;
wire	[11:0]	sCCD_B;
wire			sCCD_DVAL;
wire auto_start;
//=======================================================
//  Structural coding
//=======================================================

assign reset_n = 1'b1;
assign D5M_RESET_N=DLY_RST_1;
assign D5M_TRIGGER=1'b1;
 assign	LEDG		=	Y_Cont;

//auto start when power on
assign auto_start = ((KEY[0])&&(DLY_RST_3)&&(!DLY_RST_4))? 1'b1:1'b0;

//D5M read 
always@(posedge D5M_PIXCLK)
begin
	rCCD_DATA	<=	D5M_D;
	rCCD_LVAL	<=	D5M_LVAL;
	rCCD_FVAL	<=	D5M_FVAL;
end


//Reset module
Reset_Delay			u2	(	.iCLK(CLOCK_50_B5B),
							.iRST(KEY[0]),
							.oRST_0(DLY_RST_0),
							.oRST_1(DLY_RST_1),
							.oRST_2(DLY_RST_2),
							.oRST_3(DLY_RST_3),
							.oRST_4(DLY_RST_4)
						);
//D5M image capture
CCD_Capture			u3	(	
							.oDATA(mCCD_DATA),
							.oDVAL(mCCD_DVAL),
							.oX_Cont(X_Cont),
							.oY_Cont(Y_Cont),
							.oFrame_Cont(Frame_Cont),
							.iDATA(rCCD_DATA),
							.iFVAL(rCCD_FVAL), 
							.iLVAL(rCCD_LVAL),
							.iSTART(KEY[1]|auto_start),
							.iEND(!KEY[1]),
							.iCLK(~D5M_PIXCLK),
							.iRST(DLY_RST_2)
						);
//Bayer to RGB
RAW2RGB				u4	(	
							.iCLK(~D5M_PIXCLK),
							.iRST_n(DLY_RST_1),
							.iData(mCCD_DATA),
							.iDval(mCCD_DVAL),
							.oRed(sCCD_R),
							.oGreen(sCCD_G),
							.oBlue(sCCD_B),
							.oDval(sCCD_DVAL),
							.iX_Cont(X_Cont),
							.iY_Cont(Y_Cont)
						);
// HDMI Config - HDMI I2C
I2C_HDMI_Config u27 ( 
.iCLK(CLOCK_50_B5B),
.iRST_N(reset_n),
.I2C_SCLK(I2C_SCL),
.I2C_SDAT(I2C_SDA),
.HDMI_TX_INT(HDMI_TX_INT) 
);


basic_nios basic_nios_inst
(
	//system clocks and reset
	.clk_clk(CLOCK_50_B6A) ,	// input  clk_clk_sig
	.reset_reset_n(DLY_RST_2), 	// input  reset_reset_n_sig
   .clk_0_clk                  (CLOCK_50_B6A),                                                  //                                clk_0.clk
   .reset_0_reset_n            (DLY_RST_2),                                            //                              reset_0.reset_n
   .clk_1_clk                  (CLOCK_50_B7A),                                                  //                                clk_1.clk
   .reset_1_reset_n            (DLY_RST_2),                                            //                              reset_1.reset_n
   .video_clocks_d5m_clk_clk   (D5M_XCLKIN),                                   //                 video_clocks_d5m_clk.clk
   .video_clocks_hdmi_clk_clk  (HDMI_TX_CLK) ,  
	
	
	//LPDDR2 SDRAM Interface
	.memory_mem_ca    (DDR2LP_CA),    // memory.mem_ca
   .memory_mem_ck    (DDR2LP_CK_p),    //       .mem_ck
   .memory_mem_ck_n  (DDR2LP_CK_n),  //       .mem_ck_n
   .memory_mem_cke   (DDR2LP_CKE),   //       .mem_cke
   .memory_mem_cs_n  (DDR2LP_CS_n),  //       .mem_cs_n
   .memory_mem_dm    (DDR2LP_DM),    //       .mem_dm
   .memory_mem_dq    (DDR2LP_DQ),    //       .mem_dq
   .memory_mem_dqs   (DDR2LP_DQS_p),   //       .mem_dqs
   .memory_mem_dqs_n (DDR2LP_DQS_n), //       .mem_dqs_n
   .oct_rzqin        (DDR2LP_OCT_RZQ),         //    oct.rzqin
   .mem_if_lpddr2_emif_0_pll_ref_clk_clk          (CLOCK_50_B5B),
   .mem_if_lpddr2_emif_0_status_local_init_done   (lpddr2_local_init_done),   // mem_if_lpddr2_emif_status.local_init_done
   .mem_if_lpddr2_emif_0_status_local_cal_success (lpddr2_local_cal_success), //                          .local_cal_success
   .mem_if_lpddr2_emif_0_status_local_cal_fail    (lpddr2_local_cal_fail),    //                          .local_cal_fail

	
	 //camera input
   .camera_alt_vip_cti_0_clocked_video_vid_clk                   (D5M_PIXCLK),
   .camera_alt_vip_cti_0_clocked_video_vid_data                  ({sCCD_R[11:4],sCCD_G[11:4],sCCD_B[11:4]}),
   .camera_alt_vip_cti_0_clocked_video_vid_datavalid             (rCCD_LVAL),
   .camera_alt_vip_cti_0_clocked_video_vid_f                     (1'b0),
   .camera_alt_vip_cti_0_clocked_video_vid_h_sync                (rCCD_LVAL),
   .camera_alt_vip_cti_0_clocked_video_vid_locked                (DLY_RST_3),
   .camera_alt_vip_cti_0_clocked_video_vid_v_sync                (rCCD_FVAL),
	//camera config
	.camera_d5m_config_external_interface_SDAT (D5M_SDATA) ,	// inout  d5m_camera_config_external_interface_SDAT_sig
	.camera_d5m_config_external_interface_SCLK (D5M_SCLK) ,	// output  d5m_camera_config_external_interface_SCLK_sig
	
 
	//Video output
	.alt_vip_itc_0_clocked_video_vid_clk		(HDMI_TX_CLK) ,	// input  alt_vip_itc_0_clocked_video_vid_clk_sig
	.alt_vip_itc_0_clocked_video_vid_data		(HDMI_TX_D[23:0]) ,	// output [23:0] alt_vip_itc_0_clocked_video_vid_data_sig
	.alt_vip_itc_0_clocked_video_vid_datavalid(HDMI_TX_DE) ,	// output  alt_vip_itc_0_clocked_video_vid_datavalid_sig
	.alt_vip_itc_0_clocked_video_vid_v_sync	(HDMI_TX_VS) ,	// output  alt_vip_itc_0_clocked_video_vid_v_sync_sig
	.alt_vip_itc_0_clocked_video_vid_h_sync	(HDMI_TX_HS) 	// output  alt_vip_itc_0_clocked_video_vid_h_sync_sig


);



endmodule
